%% This function computes the minmax cut between two clustersaccording the following equation:
%     maxmincut of C1 and C2=W12/W11 + W12/W22 where
% W11 represents the number of edges in the cluster C1
% W22 represents the number of edges in the cluster C2
% W12 represents the number of edges that has one end point in C1 and the other in C2


%%
function [W_CiCj]=computecohesioncut_cicj(i,edges,adjacent_matrix)
    
  Ci=edges{i,:};
  ci_size=size( Ci,2);
  
  W_in=sum(sum(adjacent_matrix(Ci,Ci)));
  
  Cj=edges;
  Cj{i,:}=[];
  proteins=[];
  n=size(edges,1);
  for j=1:n
     proteins=cat(2,proteins,Cj{j,:});
  end
  proteins=unique(proteins);
  proteins=setdiff(proteins,Ci);
  
   
    Eout= sum(sum(adjacent_matrix(Ci,proteins)));
       %out(i)=[];
     %W_out=sum(out);
     
     max_W_in=(ci_size * (ci_size-1))/2;
     W_CiCj=(W_in/(max_W_in+Eout))/n;
     if isinf(W_CiCj) || isnan(W_CiCj)
        W_CiCj=0;
     end
    
   
%      if isnan(W_CiCj)
%          W_CiCj=1000;
%      end
  
%   W22=sum(sum(adjacent_matrix(proteinsinc2,proteinsinc2)==1));
%   W12=sum(sum(adjacent_matrix(proteinsinc1,proteinsinc2)==1));
%   c11=0;
%   c22=0;
%   c11=W12/W11;
%   c22=W12/W22;
%   
%   if isnan(c11) || isinf(c11)
%       c11=625;         
%   end
%   
%   if isnan(c22)|| isinf(c22)
%           c22=625;
%   end
%   %W_CiCj=((W12/W11)+ (W12/W22))/sum(sum(adjacent_matrix));
%    W_CiCj=(c11+ c22)/ (2*625); %sum(sum(adjacent_matrix));

end