clc;  close all;
%%
%    In this method the the population is initialized randomly.
% Identifying overlapping clusters using Genetics Algorithm Tehnique.
% MinMaxCut is used as objective Function.
% Input
% 1. adjacent_matrix of BioGrid PPI network.
% 2. polpulationsize & generationss represents the size of population and the number of generations.
% 3. chromosomes: the population which first intialized randomly.
% 4. K: an intial value which specifies the number of clusters.
% 5. matingpool represents the selected parents (tournament-based) to generate the next generation.
% 6. offsprings represent the next generation.

%%
tic;
% load ./data/BioGrid_network_Training.mat;
% load ./data/Krogan_network.mat;
load ./data/mips_network_Training.mat;
adjacent_matrix=mips_network.adjacent_matrix;
adjacent_matrix=uint8(adjacent_matrix);
polpulationsize=10;
d_generation=1;
generationssize=2;
K=400;
chromosomesize=size(mips_network.protein_list,1);
parentselectionrate=0.3;
crossoverrate=0.3;
mutationrate=0.9;
noofparents=5;    % specify the number of parents that are moved to the next generation without passing through 
                  % Crossover operator.


j=generationssize;
acc=[];
clear mips_network
%% initialize population randomly or using spectral clustering
% 1- randomly.
% 2- spectral clustering.
% 3- biclustering.

option=1;

switch (option)
    case 1

        disp('Randomly Population intialization...'); 
        [chromosomes]= initialize_population_rondomly(polpulationsize,K,chromosomesize);
        fprintf('chromosomes size %dx%d\n',size(chromosomes,1),size(chromosomes,2));
        %  chromosomes=preprocessing_chromosomes(chromosomes,chromosomesize,adjacent_matrix);
        disp('population preprocessing....');
       [chromosomes]=preprocess_population(adjacent_matrix,chromosomes,K,chromosomesize);
        polpulationsize=size(chromosomes,1);
       
    case 2
        disp('Population intialization based on spectral clustering...'); 
        % pushd('D:/Overlapping Clustering Method/Proposed Approach/spectralclustering');
        [chromosomes1]= demo_spectralClusterin(polpulationsize,chromosomesize,K);
        %[chromosomes]=initialize_population_rondomly(polpulationsize,K,chromosomesize); 
        chromosomes=zeros(polpulationsize,K*chromosomesize);
        
    case 3
        disp('Population intialization based on biclustering...'); 
        
        population(1).chrom=biclustering(adjacent_matrix, 20,K);
        
    otherwise
        chromosomes=uint8(full(chrmsms));
        
end
        fprintf('chromosomes size %dx%d\n',size(chromosomes,1),size(chromosomes,2));
 %%
  chromosomes=uint8(full(chromosomes));
 while(j>0)
     offsprings=[];
     fprintf('Generation <#%d>\n',d_generation);
     %% Compute fitness of all individuals
     [accuracy,chromosomes]=GAOCM(chromosomes,K,adjacent_matrix);
     fprintf('<After>: chromosomes size %dx%d\n\n\n',size(chromosomes,1),size(chromosomes,2));
%       accuracy=vpa(accuracy,6);
    
%% selection method
fprintf('Parent selection Process\n');
i=1;
matingpoolsize=polpulationsize-noofparents;
randomcompetiters=[];
maxfit=0;
matingpool=[];
winners=[];
acc=accuracy;
%% moving the best X parents to the next generation
 sorted_accuracy=sort(accuracy,'descend');
 selected_idx=[];
 for k=1:noofparents
 [l,idx]=ismember(sorted_accuracy(k),accuracy);
 selected_idx=cat(1,selected_idx,idx);
 accuracy(idx)=[];
 end
 offsprings=chromosomes(selected_idx,:);
 
%  accuracy(idx)=[];
%  accuracy=vpa(accuracy,6);
 %%
while (i<=matingpoolsize)
    
       
    selected_parent1_index=select_parent(accuracy,rand(1));
%     selected_parent2_index=select_parent(accuracy,max(fit).*rand(1));
    selected_parent2_index=select_parent(accuracy,rand(1));
    
    %% single point crossover
    fprintf('\n\single point crossover Process\n');
    crossoverpoint=200;
    child1=[];
    child2=[];
    parent1=[];
    parent2=[];
    
    parent1=vec2mat(chromosomes(selected_parent1_index,:),chromosomesize);
    parent2=vec2mat(chromosomes(selected_parent2_index,:),chromosomesize);
    r=rand(1);
    if r<crossoverrate
       child1=uint8([parent1(:,1:crossoverpoint) parent2(:,(crossoverpoint+1):chromosomesize)]);
       child2=uint8([parent2(:,1:crossoverpoint) parent1(:,(crossoverpoint+1):chromosomesize)]); 
    else
       child1= uint8(parent1);
       child2= uint8(parent2);
    end
     fprintf('mutation process for individual <#%d>\n',i);
     fprintf('<Beformutation>: child1 size %dx%d\n',size(child1,1),size(child1,2));
     fprintf('<Beformutation>: child2 size %dx%d\n',size(child2,1),size(child2,2));
    %% mutation process
    [child11]=mutate(child1,mutationrate);
    [child12]=mutate(child2,mutationrate);
   
    fprintf('<Aftermutation>: child1 size %dx%d\n\n\n',size(child11,1),size(child1,2));
    fprintf('<Aftermutation>: child2 size %dx%d\n\n\n',size(child12,1),size(child2,2));
    child1=reshape(child11',1,K*chromosomesize);
    child2=reshape(child12',1,K*chromosomesize);

    offsprings(size(offsprings,1)+1,:)=child1;
    offsprings(size(offsprings,1)+1,:)=child2;

    clear child1 child2 parent1 parent2
    i=i+2;
end
fprintf('<After>: offsprings size %dx%d\n\n\n',size(offsprings,1),size(offsprings,2));
chromosomes=offsprings;
 fprintf('<After>: chromosomes size %dx%d\n\n\n',size(chromosomes,1),size(chromosomes,2));

 j=j-1;
 d_generation=d_generation+1;
 end
 h=msgbox('Done');
 toc;